ToDoApp/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include

from task.views import ShowTask, ShowTaskDetail, MakeDone
from user.views import CreateUser, LandingPageView, LogInView

urlpatterns = [
    path("", LandingPageView.as_view()),
    path('admin/', admin.site.urls),
    path("task/", include('task.urls')),
    path("tasklist", ShowTask.as_view(), name="show_task"),
    path("taskdetail/<int:pk>/", ShowTaskDetail.as_view(), name="task_detail"),
    path("maketaskdone/<int:pk>", MakeDone.as_view(), name="task_done"),
    path("createuser/", CreateUser.as_view(), name="create_user"),
    path("login/", LogInView.as_view(), name="login")
]
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

task/urls.py
from django.urls import path

from task.views import CreateTaskForm, ShowTask

urlpatterns = [
    path("create/", CreateTaskForm.as_view(), name="create_task"),
    path("create/done/", ShowTask.as_view())
]

task/models.py
from django.db import models

# Create your models here.
from django.utils.translation import ugettext_lazy as _

from lib.model import BaseModel
from task.validators import validate_file_extension
from user.models import Profile


class Task(BaseModel):
    NECESSARY = 1
    IMPORTANT = 2
    USUAL = 3
    INDIFFERENT = 4
    priority_choice = (
        (NECESSARY, "necessary"),
        (IMPORTANT, "important"),
        (USUAL, "usual"),
        (INDIFFERENT, "indifferent"),
    )
    title = models.CharField(max_length=90, verbose_name=_("title"))
    description = models.TextField(verbose_name=_("description"), blank=True)
    attachment = models.FileField(
        verbose_name=_("attachment"), validators=[validate_file_extension],
        upload_to="task/CreateTask/attachments/", blank=True
    )
    image = models.ImageField(
        verbose_name=_("image"), upload_to="task/CreateTask/image/", blank=True
    )
    time = models.TimeField(verbose_name=_("time"), blank=True, null=True)
    date_time = models.DateField(verbose_name=_("date time"), blank=True, null=True)
    is_done = models.BooleanField(verbose_name=_("is done"), default=False)
    priority = models.IntegerField(
        verbose_name=_("priority"), choices=priority_choice
    )
    user = models.ForeignKey(
        Profile, verbose_name=_("user"), on_delete=models.CASCADE
    )

    class Meta:
        verbose_name = _("task")
        verbose_name_plural = _("tasks")

    def __str__(self):
        return self.title

task/forms.py
from django.forms import ModelForm, TimeInput, TextInput
#from bootstrap3_datetime.widgets import DateTimePicker
from task.models import Task


class TaskForm(ModelForm):
    class Meta:
         model = Task
         fields = (
             "title", "description", "attachment", "image", "time",
             "date_time", "priority"
         )
         widgets = {
             'time': TextInput(
                 attrs={'type': 'time'}
             ),
             "date_time": TextInput(
                 attrs={'type': 'date'}
             )
         }

    def save(self, commit=False, user=None):
        task = Task.objects.create(
            title=self.cleaned_data["title"],
            description=self.cleaned_data["description"],
            attachment=self.cleaned_data["attachment"],
            image=self.cleaned_data["image"],
            time=self.cleaned_data["time"],
            date_time=self.cleaned_data["date_time"],
            is_done=False,
            priority=self.cleaned_data["priority"],
            user=user
        )
        return task

task/views.py
from django.shortcuts import render, redirect

# Create your views here.
from django.views import View
from django.views.generic import FormView, ListView, DetailView, RedirectView

from task.forms import TaskForm
from task.models import Task


class CreateTaskForm(FormView):
    form_class = TaskForm
    template_name = "task/createtask.html"
    success_url = "done/"

    def form_valid(self, form):
        form.save(commit=True, user=self.request.user.user)
        return super().form_valid(form)


class ShowTask(ListView):
    model = Task
    template_name = "task/tasklist.html"

    def get_queryset(self):
        queryset = super().get_queryset()
        queryset = queryset.filter(user=self.request.user.user, is_done=False).all()
        return queryset.all()


class ShowTaskDetail(DetailView):
    model = Task
    template_name = "task/taskdetail.html"
    context_object_name = "detail"

    def get_queryset(self):
        queryset = super().get_queryset()
        queryset = queryset.filter(pk=self.kwargs["pk"])
        return queryset


class MakeDone(View):
    # def get_object(self):
    #     task = Task.objects.get(pk=self.kwargs["pk"])
    #     return task

    def post(self, request, *args, **kwargs):
        #target_task = self.get_object()
        # if target_task.pk == self.kwargs["pk"]:
        Task.objects.filter(pk=self.kwargs["pk"]).update(is_done=True)
        return redirect("/tasklist")

templates/task/base.html
<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css" integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="anonymous">
    <title>{% block title %}{% endblock %}</title>
  </head>
  <body>
    <div class="container">
      <div class="row justify-content-center">
        <div class="col-8">
          <h1 class="mt-2">{% block title2 %}{% endblock %} </h1>
          <hr class="mt-0 mb-4">
          {% block content %}
          {% endblock %}
        </div>
      </div>
    </div>
  </body>
</html>
</html>

templates/task/createtask.html
{% extends 'task/base.html' %}

{% load crispy_forms_tags %}
{% block title2 %} Create Task{% endblock %}
{% block title %} Create Task {% endblock %}
{% block content %}
  <form method="post" novalidate>
    {% csrf_token %}
    {{ form|crispy }}
    <button type="submit" class="btn btn-success">Save Task</button>
  </form>
{% endblock %}

templates/task/taskdetail.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css" integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="anonymous">
</head>

<body>
    <div class="container">
      <div class="row justify-content-center">
        <div class="col-8">
          <h1 class="mt-2">Task Detail </h1>
          <hr class="mt-0 mb-4">


    <h1 class="mb-1">{{detail.title|title}}</h1>
    <h3>{{detail.description|default:"No Description" }}</h3>
    <h3>{{detail.time|time:"H:i"}}</h3>
    <h3>{{detail.date_time|date:"D d M Y"}}</h3>
    <h3>{{detail.get_priority_display}}</h3>
    <img alt="image" src="{{detail.imagel}}">
       </div>
</body>
</html>

templates/task/tasklist.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Task List</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
</head>

<body>
    <div class="container">
      <div class="row justify-content-center">
        <div class="col-8">
          <h1 class="mt-2">Tasks List </h1>
          <hr class="mt-0 mb-4">
   <div class="list-group">
       <h4>Do you want to create task?</h4>
             <form>
                    <input type="button" value="Create Task" onclick="window.location.href='{% url 'create_task' %}'" class="btn btn-info" />
                    </form>

  {% for task in object_list %}
  <a href="{% url 'task_detail' task.id %}" class="list-group-item list-group-item-action flex-column align-items-start">
    <div class="d-flex w-100 justify-content-between">
      <h5 class="mb-1"> {{task.title}}</h5>

      <small class="text-muted">{{task.time|time:"H:i"}}</small>

    </div>
      <div>
        <span>
            <form action="{% url 'task_done' task.id %}" method="post">
            {% csrf_token %}
        <button type="submit" class="btn btn-success">Done</button>
            </form>
        </span>
          </div>
    <small class="text-muted">{{task.get_priority_display}}</small>
  {% endfor %}
</body>
</html>